<template>
  <div class="el-tree">
    <header-breadcrumb
      title="register"
      class="bg-background3"
      style="font-size: 16px; height: 54px !important"
    />
    <div
      class="px-10 bg-1 h-screen overflow-auto bg-[var(--background5)] relative z-[99] pb-28"
    >
      <el-form
        label-position="top"
        ref="formRef"
        :rules="formRules"
        :model="formModel"
        class="mb-10"
      >
        <el-form-item
          :class="{ required: rules.Username.required }"
          :label="$t('username')"
          prop="Username"
        >
          <el-input
            v-model="formModel.Username"
            :placeholder="$t('username')"
          />
        </el-form-item>
        <el-form-item
          :class="{ required: rules.Password.required }"
          :label="$t('password')"
          prop="Password"
        >
          <el-input
            :type="inputTypePw"
            v-model="formModel.Password"
            :placeholder="$t('password')"
          >
            <template #suffix>
              <div @click.prevent="showPassword('password')">
                <font-awesome-icon v-if="isShowPassword" icon="eye-slash" />
                <font-awesome-icon v-else icon="eye" />
              </div>
            </template>
          </el-input>
        </el-form-item>
        <el-form-item
          :class="{ required: rules.ConfirmPassword.required }"
          :label="$t('confirm_password')"
          prop="ConfirmPassword"
          show-password
        >
          <el-input
            :type="inputTypecfPw"
            v-model="formModel.ConfirmPassword"
            :placeholder="$t('confirm_password')"
          >
            <template #suffix>
              <div @click.prevent="showPassword('cfpassword')">
                <font-awesome-icon v-if="isShowcfPassword" icon="eye-slash" />
                <font-awesome-icon v-else icon="eye" />
              </div>
            </template>
          </el-input>
        </el-form-item>
        <el-form-item
          :class="{ required: rules.Currency.required }"
          :label="$t('currency')"
          prop="Currency"
        >
          <el-select
            v-model="formModel.Currency"
            style="width: 100%"
            :placeholder="$t('select_currency')"
            :disabled="currencies.length <= 0"
          >
            <el-option
              v-for="currency in currencies"
              :key="currency"
              :value="String(currency.Currency)"
            >
              <div class="flex justify-between w-full">
                <div class="flex items-center">
                  <div>
                    {{ currency.Currency }}
                  </div>
                  <div class="w-[16px] ml-[11px] currency-check-icon">
                    <font-awesome-icon icon="circle-check" />
                  </div>
                </div>
              </div>
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item
          v-for="property in availableProperties"
          :key="property.PropertyName"
          :label="property.PropertyNameForDisplay"
          :prop="property.PropertyName"
          :class="{ required: rules[property.PropertyName].required }"
        >
          <el-select
            v-if="property.PropertyName === 'Bank'"
            v-model="formModel.Bank"
            style="width: 100%"
            :placeholder="$t('select_bank')"
            :disabled="bankOptions.length <= 0"
          >
            <el-option
              v-for="bank in bankOptions"
              :key="bank.Id"
              :label="bank.BankName"
              :value="String(bank.Id)"
            >
              <div class="flex justify-between w-full">
                <div class="flex items-center">
                  <div>
                    {{ bank.BankName }}
                  </div>
                  <div class="w-[16px] ml-[11px] bank-check-icon">
                    <font-awesome-icon icon="circle-check" />
                  </div>
                </div>
              </div>
            </el-option>
          </el-select>
          <div v-else-if="property.PropertyName === 'Gender'">
            <el-radio v-model="formModel.Gender" label="male">{{
              $t("male")
            }}</el-radio>
            <el-radio v-model="formModel.Gender" label="female">{{
              $t("female")
            }}</el-radio>
          </div>
          <el-date-picker
            v-else-if="property.PropertyName === 'DateOfBirth'"
            v-model="formModel.DateOfBirth"
            type="date"
            value-format="YYYY-MM-DD"
          />
          <el-input
            v-else-if="property.PropertyName === 'Phone'"
            v-model="formModel[property.PropertyName]"
            :placeholder="property.PropertyName"
          >
            <template #suffix>
              <el-tooltip
                class="box-item"
                effect="dark"
                :content="
                  $t(
                    'valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes'
                  )
                "
                placement="bottom"
              >
                <el-icon class="el-input__icon" color="var(--primary)">
                  <info-filled />
                </el-icon>
              </el-tooltip>
            </template>
          </el-input>
          <el-input
            v-else-if="property.PropertyName === 'Referral'"
            :disabled="referralQuery.length"
            v-model="formModel[property.PropertyName]"
            :placeholder="$t('referral')"
          ></el-input>
          <el-input
            v-else
            v-model="formModel[property.PropertyName]"
            :placeholder="property.PropertyNameForDisplay"
          ></el-input>
        </el-form-item>
        <el-form-item
          v-if="cashAgentQuery.length"
          :label="$t('agent_name')"
          prop="AgentName"
        >
          <el-input
            :disabled="cashAgentQuery.length"
            v-model="formModel.AgentName"
          />
        </el-form-item>
        <el-form-item
          v-if="!reCaptcha.IsHidden && reCaptchaSiteKey !== ''"
          :class="[isVerified ? 'verify__recaptcha__success' : '']"
          prop="Recaptcha"
        >
          <re-captcha
            :sitekey="reCaptchaSiteKey"
            :load-recaptcha-script="true"
            id="registerCaptcha"
            @verify="onVerify"
            @error="onRecaptchaError"
            @expired="onRecaptchaError"
          ></re-captcha>
        </el-form-item>
        <el-form-item prop="Captcha" v-if="!clientCaptcha.IsHidden">
          <div class="captcha">
            <captcha :value="formModel.Captcha" @isValid="getCaptchaErrorMsg" />
            <el-input
              type="text"
              v-model="formModel.Captcha"
              id="registerCaptchaValidationCode"
              :placeholder="$t('enter_validation_code')"
            />
          </div>
        </el-form-item>
        <template class="flex justify-center">
          <div class="mt-5">
            <el-button
              @click="onRegister(formRef)"
              :loading="isLoading"
              type="primary"
              round
              >{{ $t("submit") }}</el-button
            >
          </div>
        </template>
      </el-form>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from "vue";
import useRegister from "@/composables/useRegister";
import { store } from "@/store";

export default defineComponent({
  setup() {
    const showRegisterDialog = computed(() => store.state.showRegisterDialog);
    const inputTypePw = ref("password");
    const inputTypecfPw = ref("password");
    const isShowPassword = ref(false);
    const isShowcfPassword = ref(false);
    const showPassword = (input: string) => {
      if (input === "password" && inputTypePw.value === "text") {
        inputTypePw.value = "password";
        isShowPassword.value = false;
      } else if (input === "password" && inputTypePw.value === "password") {
        inputTypePw.value = "text";
        isShowPassword.value = true;
      } else if (input === "cfpassword" && inputTypecfPw.value === "text") {
        inputTypecfPw.value = "password";
        isShowcfPassword.value = false;
      } else {
        inputTypecfPw.value = "text";
        isShowcfPassword.value = true;
      }
    };
    const {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      isLoading,
      rules,
    } = useRegister();
    return {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      showRegisterDialog,
      isShowcfPassword,
      isShowPassword,
      inputTypePw,
      inputTypecfPw,
      showPassword,
      isLoading,
      rules,
    };
  },
});
</script>

<style scoped>
.el-form-item.is-error.verify__recaptcha__success
  > :where(.el-form-item__content)
  > :deep(.el-form-item__error) {
  display: none;
}
:deep(.main__bg) {
  background: var(--background3);
  border-bottom: 1px solid var(--background4);
  padding: 16px;
}
:deep(.el-form--label-top) {
  @apply mt-8;
}
.svg-inline--fa {
  color: var(--text);
}
.selected {
  color: var(--hint) !important;
}
:deep(.el-input__inner) {
  background-color: var(--background1);
  height: 48px !important;
  border-radius: 8px;
}
.bg-1 {
  background-color: var(--background2);
}
.el-button.el-button--primary {
  --el-button-text-color: var(--textBtn);
  --el-button-bg-color: rgb(49, 196, 110);
  --el-button-border-color: rgb(49, 196, 110);
  --el-button-hover-text-color: var(--textBtn);
  --el-button-hover-bg-color: rgb(107, 82, 203);
  --el-button-hover-border-color: rgb(107, 82, 203);
}
.el-input {
  --el-input-focus-border-color: rgb(49, 196, 110);
}
.text-primary {
  color: var(--primary);
}
:deep(button.el-button) {
  width: 142px;
  height: 40px;
  background-color: var(--primary);
  border: none;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
.selected .currency-check-icon {
  display: block;
}
.currency-check-icon {
  display: none;
}
.selected .bank-check-icon {
  display: block;
}
.bank-check-icon {
  display: none;
}
.captcha {
  width: 100%;
}
.vue_client_recaptcha {
  height: 65px;
  margin-bottom: 18px;
}
:deep(.vue_client_recaptcha_icon) {
  width: 50%;
}
:deep(.vue_client_recaptcha .captcha_canvas) {
  width: 100%;
}
:deep(.el-input__suffix) {
  @apply flex items-center;
}
:deep(.fc-textBtn) {
  color: var(--text5);
}
:deep(.el-tree .m-back-header-btn .svg-inline--fa) {
  color: var(--text5);
}
</style>
